#!/bin/sh

#test if X is running,  and set DIALOG

DCHECK=`ps |grep "/usr/X11R6/bin/xinit"|grep -v "grep"`
echo --- $DCHECK ---

DIALOG=Xdialog
if [ "$DCHECK" = "" ]; then
DIALOG=dialog
fi

#### Find out where we are (more reliable than pwd with rox)
MYDIR=`echo $0|sed 's/[^/]*$//'|sed 's/\/$//'`

if [ "$MYDIR" = "." ]; then
  MYDIR=`pwd`
fi



#FOLDER=~
FOLDER=/usr/local

#### normal users (not root) just are allowed to extract to their /home
if [ "$FOLDER" != ~ ]; then
  IAM=`whoami`
  if [ "$IAM" != "root" ]; then
     $DIALOG --title "info" --msgbox "ERROR: You must be root to install xfce4_with_rox-startupfiles, exiting..." 10 60
      clear
     exit
  fi
fi

if [ ! -d "$FOLDER" ] ;then
  mkdir $FOLDER
fi

cd $FOLDER



#### If folder exists and is empty (PCCC does not remove it), start uninstaller
ACTION=install
if [ -f "/root/.packages/xfce4_with_rox-startupfiles.files" ]; then

    #ACTION=`xmessage -nearmouse -print -buttons un-install,re-install "xfce4_with_rox-startupfiles already exists, your choice?"`

     $DIALOG --no-cancel --menu "xfce4_with_rox-startupfiles already exists, your choice?" 10 60 2 "1" "re-install" "2" "un-install" 2>/tmp/dpimenu.txt
     ACTION=`tail -n 1 /tmp/dpimenu.txt`
fi

echo $ACTION

#### Uninstall
if [ "$ACTION" = "2" ]; then

   if [ -f "/root/.packages/xfce4_with_rox-startupfiles.files" ];then
     $DIALOG  --title "info" --msgbox "starting Pup-get Package-manager" 10 60
      pupget&
      exit 0
   fi

   exit 0
fi

if [ "$ACTION" = "1" ]; then
  ACTION=install
fi

if [ "$ACTION" != "install" ]; then
   exit 0
fi


#### install

##V03 #######################################################
# extract FILESYSTEM.tgz



# first check, if files in systemfolders already exist

 rm -f  "$MYDIR/existing.txt"
 if [ -f "$MYDIR/FILESYSTEM.tgz" ] ; then
   tar -tzf "$MYDIR/FILESYSTEM.tgz" | while read a; do 

   if [ -f "/$a" ] ; then
      echo "/$a" |sed 's^- ' | sed 's$' >>  "$MYDIR/existing.txt"
   fi
   done
  fi

# check, if files in applicationfolder already exist

 if [ -f "$MYDIR/xfce4_with_rox-startupfiles.tgz" ] ; then
   tar -tzf "$MYDIR/xfce4_with_rox-startupfiles.tgz" | while read a; do 

   if [ -f "$FOLDER/$a" ] ; then
      echo "$FOLDER/$a" |sed 's^- ' | sed 's$' >> "$MYDIR/existing.txt"
   fi
   done
  fi

 if [ -f "$MYDIR/existing.txt" ]; then
  
        FILES=`cat "$MYDIR/existing.txt"`



   $DIALOG --menu "These files already exist, overwrite them?" 20 70 14 $FILES 2>/tmp/dpimenu.txt


  if [ "$?" != "0" ];then
    $DIALOG --title "info" --msgbox "Installation canceled, exiting..." 6 60
      clear
    exit 0
  fi
 fi

 if [ -f "$MYDIR/FILESYSTEM.tgz" ] ; then
   cd /
   tar -xzvf "$MYDIR/FILESYSTEM.tgz"
 fi
##/V03 #######################################################



#### extract archive
  cd $FOLDER
  tar -xzvf "$MYDIR/xfce4_with_rox-startupfiles.tgz"

  #### were there any errors?
  if [ ! -d "$FOLDER/xfce4_with_rox-startupfiles" ]; then
    $DIALOG --title "info" --msgbox "Error during extraction - are you root?" 6 60
      clear
    exit 1
  fi

########################################
# generate menue-entries for the Windowmanagers

if [ -f "$MYDIR/wxbmenue.rc" ];then

MYFILE=`head -n 1 "$MYDIR/wxbmenue.rc"`
rm -f /tmp/mrc1

fi

if [ -f "$MYFILE" ]; then


#############################
## generate Entry for wxB-menue



  FILE=$FOLDER/$MYFILE
  echo "<?xml version=\"1.0\"?>" >/tmp/mrc1
  echo "<RootMenu>" >>/tmp/mrc1
  echo "<Menu label=\"DotPups\" icon=\"nothing.xpm\">" >>/tmp/mrc1

  ### check, if there already is a "DotPups"-submenue
  MENUEXISTED=1
  MYGREP=`grep "<Menu label=\"DotPups\"" ~/.myownmenuerc`
  if [ "$MYGREP" = "" ];then
    MENUEXISTED=0
  fi
  ### delete old entries
  rm -f /tmp/mrc0
  cat ~/.myownmenuerc |sed "s^<Program.label=.xfce4_with_rox-startupfiles..*$g" |while read a ;
  do if [ "$a" ];then echo $a>>/tmp/mrc0;fi;done

  if [ "$MYFILE" ];then 
    echo "<Program label=\"xfce4_with_rox-startupfiles\" icon=\"$FOLDER/xfce4_with_rox-startupfiles/icon.xpm\">$FILE</Program>" >>/tmp/mrc1
  fi
  if [ "$MENUEXISTED" = "0" ];then
    echo "</Menu>" >>/tmp/mrc1
  fi

  cat /tmp/mrc0 |sed "s/<.xml.*$//" |sed "s/<RootMenu>.*$//"  |sed "s/<.RootMenu>.*$//" |sed "s/<Menu.label=.DotPups.*$//" |sed "s/^$//g" |while read a ;
  do if [ "$a" ];then echo $a>>/tmp/mrc1;fi;done

  echo "</RootMenu>" >>/tmp/mrc1
  cp  ~/.myownmenuerc  ~/.myownmenuerc.bak
  mv /tmp/mrc1  ~/.myownmenuerc
  if [ "$MYFILE" ];then 
      #xmessage -nearmouse "added entry to wxB-Menue. You must restart the menue to see it."
INSTALLEDMENUES1="wxB-Menue"
  fi
  rm -f /tmp/mrc0


  MYFILE=`head -n 1 "$MYDIR/wxbmenue.rc"`
  BINARYNAME=`echo $MYFILE | sed "s^.*/"`

#############################
## generate Entry for fvwm95
  ### register in the fvwm95 menu
  # entry is placed just above smm
  FVWM95RC="/root/.fvwm95rc"
  if [ -f $FVWM95RC ] ; then

  MYGREP=`grep "AddToMenu \"DotPups\"" $FVWM95RC`
  if [ "$MYGREP" = "" ];then

      cp -f $FVWM95RC /tmp/DOTfvwm95.pwizard_patched.backup
      EDITTEXT="s\(Popup.UtilityApps$\)\1\n+ \"DotPups%package.xpm%\" Popup DotPups"
      sed -e "$EDITTEXT" $FVWM95RC >/tmp/patchedinstall.tmp
      sleep 1
      echo "DestroyMenu \"DotPups\"" >>/tmp/patchedinstall.tmp
      echo "AddToMenu \"DotPups\"" >>/tmp/patchedinstall.tmp
      mv -f /tmp/patchedinstall.tmp $FVWM95RC
  #    sleep 1
  fi

    # this option is used to prevent the entry from going in more than once
    grep "$FOLDER/$MYFILE" $FVWM95RC
    if [ $? -ne 0 ] ;then
      cp -f $FVWM95RC /tmp/DOTfvwm95.pwizard_patched.backup
      EDITTEXT="s^\(AddToMenu.\"DotPups\".*$\)\1\n+ \"$BINARYNAME%$FOLDER/xfce4_with_rox-startupfiles/icon.xpm%\" Exec exec $FOLDER/$MYFILE"
      sed -e "$EDITTEXT" $FVWM95RC >/tmp/patchedinstall.tmp
      mv -f /tmp/patchedinstall.tmp $FVWM95RC
   #   sleep 1
INSTALLEDMENUES2="Fvwm95"

    fi
  fi 

#############################
## generate Entry for icewm
  ### register in the icewm menu
  # entered just above smm
  ICEWMMENU="/root/.icewm/menu"

  if [ -f $ICEWMMENU ] ; then
  MYGREP=`grep "menu \"DotPups\"" $ICEWMMENU`
  if [ "$MYGREP" = "" ];then
    echo "menu \"DotPups\" dotpups {" >>$ICEWMMENU
    echo "}" >>$ICEWMMENU
  fi

    # this option is used to prevent the entry from going in more than once
    grep "$FOLDER/$MYFILE" $ICEWMMENU
    if [ $? -ne 0 ] ;then
      cp -f $ICEWMMENU /tmp/icewmmenu.pwizard.backup
      EDITTEXT="s^\(menu.\"DotPups\".dotpups.{\)\1\n\tprog \"$BINARYNAME\" \"$FOLDER/xfce4_with_rox-startupfiles/icon.xpm\" $FOLDER/$MYFILE"
      sed -e "$EDITTEXT" $ICEWMMENU >/tmp/patchedinstall.tmp
      mv -f /tmp/patchedinstall.tmp $ICEWMMENU
INSTALLEDMENUES3="IceWM"
    fi
  fi

#############################
## generate Entry for jwm
  ### register in the jwm menu
  # entry is just above smm
  JWMRC="/root/.jwmrc"

  if [ -f $JWMRC ] ; then  

  MYGREP=`grep "<Menu label=\"DotPups\"" $JWMRC`
  if [ "$MYGREP" = "" ];then

      cp -f $JWMRC /tmp/DOTjwm.pwizard_patched.backup
      EDITTEXT="s\(<RootMenu.label.*$\)\1\n<Menu label=\"DotPups\" icon=\"package.xpm\">\n</Menu>"
      sed -e "$EDITTEXT" $JWMRC >/tmp/patchedinstall.tmp
      sleep 1
      mv -f /tmp/patchedinstall.tmp $JWMRC
      sleep 1
  fi
    # this option is used to prevent the entry from going in more than once
    grep "$FOLDER/$MYFILE" $JWMRC
    if [ $? -ne 0 ] ;then
      cp -f $JWMRC /tmp/DOTjwm.pwizard_patched.backup
      EDITTEXT="s^\(<Menu.label=\"DotPups\".*$\)\1\n<Program label=\"$BINARYNAME\" icon=\"$FOLDER/xfce4_with_rox-startupfiles/icon.xpm\">$FOLDER/$MYFILE</Program>"
      sed -e "$EDITTEXT" $JWMRC >/tmp/patchedinstall.tmp
      mv -f /tmp/patchedinstall.tmp $JWMRC
      sleep 1
INSTALLEDMENUES4="JWM"
    fi
  fi 


    INSTALLEDMENUESCHECK=$INSTALLEDMENUES1$INSTALLEDMENUES2$INSTALLEDMENUES3$INSTALLEDMENUES4
    INSTALLEDMENUESALL="\n$INSTALLEDMENUES1\n$INSTALLEDMENUES2\n$INSTALLEDMENUES3\n$INSTALLEDMENUES4\n"
    if [ "$INSTALLEDMENUESCHECK" != ""  ];then
      $DIALOG --title "info" --msgbox "Added Menue-entries to $INSTALLEDMENUESALL\nYou must restart them (except Icewm) to see them." 16 60
    fi
################################################
## generate symbolic link in /usr/local/bin

  BINARYNAME=`echo $MYFILE | sed "s^.*/"`
  APPSYMLINK="/usr/local/bin/$BINARYNAME"

  if [ -f "$APPSYMLINK" ];then

    MSG="There already is a file $BINARYNAME in /usr/local/bin.\n\nMay I overwrite it with a symlink to \n$FOLDER/$MYFILE?"
    $DIALOG --title "info" --yesno "$MSG" 14 60

    if [ "$?" = "0" ];then
      USESYMLINK=yes
      rm -f "$APPSYMLINK"
      ln -s "$FOLDER/$MYFILE" "$APPSYMLINK"
    fi
  else
      USESYMLINK=yes
      ln -s "$FOLDER/$MYFILE" "$APPSYMLINK"
  fi
#############################

fi # //if [ -f "$MYFILE" ] then

## delete the application-folder, if it is empty

    rmdir "$FOLDER/xfce4_with_rox-startupfiles"


  #### test if PCCC is available (Puppy-Linux)
  if [ ! -f "/root/.packages/packages.txt" ];then

      #### finally open the new folder in Rox and display "goodbye" (Systems without PCCC)
      rox "$FOLDER/xfce4_with_rox-startupfiles"   
      $DIALOG --title "info" --msgbox "Finished installation." 6 60
      clear
      exit 0
  fi

  #### register to PCCC


      #### register to PCCC
      #### avoid double entries in PCCC
      MYGREP=`grep "xfce4_with_rox-startupfiles" /root/.packages/alienpackages.txt`
      if [ "$MYGREP" = "" ];then
        echo \"xfce4_with_rox-startupfiles\" \"xfce4_with_rox-startupfiles\" on \"\" \\>>/root/.packages/alienpackages.txt
      fi

      #### Register Keyword to PCCC , only if it has Menueentries
      if [ -f "$MYFILE" ]; then
        echo xfce4_with_rox-startupfiles>/root/.packages/xfce4_with_rox-startupfiles.keyword
      fi
      #### Register filelist to PCCC
      rm -f /root/.packages/xfce4_with_rox-startupfiles.files
      tar -tzf "$MYDIR/xfce4_with_rox-startupfiles.tgz" | while read a; do echo "$FOLDER/$a"|sed "s/^.*\/$//"|grep -v "^$" >>/root/.packages/xfce4_with_rox-startupfiles.files ; done
      cat "$MYDIR/config.files" |sed "s/^.*\/$//"|grep -v "^$" >> /root/.packages/xfce4_with_rox-startupfiles.files

      if [ "$USESYMLINK" = "yes" ];then
        echo "$APPSYMLINK"|sed "s/^.*\/$//"|grep -v "^$" >> /root/.packages/xfce4_with_rox-startupfiles.files
      fi

      ## V03 ##########################################################################################
      ###do the same with files from root.tgz and usr.tgz
      tar -tzf "$MYDIR/FILESYSTEM.tgz" | while read a; do echo "/$a"|sed "s/^.*\/$//"|grep -v "^$" >>/root/.packages/xfce4_with_rox-startupfiles.files ; done


      #### finally open the new folder in Rox and display "goodbye" (Puppy: PCCC was used)
      if [ -d "$FOLDER/xfce4_with_rox-startupfiles" ] ; then
        rox "$FOLDER/xfce4_with_rox-startupfiles"
      fi

      $DIALOG --title "info" --msgbox "Finished installation.\nTo Uninstall xfce4_with_rox-startupfiles, use the Pup-Get Package-Manager" 8 60
      clear

